--[[ For normal milling w/o information for skipped "herbs" the macro should be: /run MillButtonSetup() /click MillButton ]]
--[[ For normal milling w/ information for skipped "herbs" the macro should be: /run MillButtonSetup2() /click MillButton ]]

local L = LibStub("AceLocale-3.0"):GetLocale("MillButton")
local mill = CreateFrame("CheckButton","MillButton",UIParent,"SecureActionButtonTemplate")
mill:SetAttribute("type","macro")
local _, _, _, _, _, item_herb = GetAuctionItemSubClasses(6) --Simple way to get ingame localized ItemType "Herb" through Auctionshouseframe translation
local mill_spell = GetSpellInfo(51005) --SpellID for Milling

local function findherb()
	for bag=0,4 do	--search only in our bags for herbs 0=default bag 1 to 4 additional bagslots
		for slot=1,GetContainerNumSlots(bag) do		--start at slot 1
			local itemID = GetContainerItemID(bag, slot)
			local _, count = GetContainerItemInfo(bag, slot)
			if itemID then
				local itemName, itemLink, _, _, _, _, itemType = GetItemInfo(itemID)
				for i = 1, #MillButtonExpansions do
					local expansion = MillButtonExpansions[i]
					if (MillButtonDB[expansion][itemID]) and count >= 5 then
						return bag, slot
					end
				end
				for i = 1, #MillButtonExpansions do
					local expansion = MillButtonExpansions[i]
					if itemType==item_herb and MillButtonDB[expansion][itemID]==false and MillButtonSettings.extended==true then
					local itemName, itemLink, _, _, _, _, itemType = GetItemInfo(itemID)
						DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..count.."x "..itemLink.." "..L["skipped"])
					end
				end
			end
		end
	end
end

function MillButtonSetup()
extended_millbutton = false
	local bag, slot = findherb()
	if (not bag or not slot) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
	-- do nothing if no herb, if looting or casting
		MillButton:SetAttribute("macrotext","")
		if not bag then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
		end
	else
		MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..mill_spell.."\n/"..L["macro_use"].." "..bag.." "..slot)
	end
end

function MillButtonSetup2()
extended_millbutton = true
	local bag, slot = findherb()
	if (not bag or not slot) or LootFrame:IsVisible() or CastingBarFrame:IsVisible() or UnitCastingInfo("player") then
	-- do nothing if no herb, if looting or casting
		MillButton:SetAttribute("macrotext","")
		if not bag then
			DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00MillButton: |r"..L["error"])
		end
	else
		MillButton:SetAttribute("macrotext","/"..L["macro_cast"].." "..mill_spell.."\n/"..L["macro_use"].." "..bag.." "..slot)
	end
end